/*
 * ATLAS
 * Architecture and Tools for Linguistic Analysis Systems
 * Author: Chris Laprun, Sylvain Pajot
 *
 * This software was developed at the National Institute of Standards and Technology by
 * employees of the Federal Government in the course of their official duties.  Pursuant to
 * Title 17 Section 105 of the United States Code this software is not subject to copyright
 * protection within the United States and is in the public domain. jATLAS is
 * an experimental system.  NIST assumes no responsibility whatsoever for its use by any party.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS."  With regard to this software, NIST MAKES NO EXPRESS
 * OR IMPLIED WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING MERCHANTABILITY,
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 */

package gov.nist.atlas.impl;

import gov.nist.atlas.Metadata;
import gov.nist.atlas.MetadataHolder;
import gov.nist.atlas.type.ATLASType;


/**
 * @version $Revision: 1.2 $
 * @author Christophe Laprun
 */
class MetadataHolderImpl implements MetadataHolder {
  protected MetadataHolderImpl(ATLASType type) {
    // type can be null. If it is no check is done when setting metadata
    this.type = type;
  }

  public Metadata getMetadata() {
    return metadata;
  }

  public boolean setMetadata(Metadata metadata) {
    if (type == null || type.canSetMetadata(metadata)) {
      this.metadata = metadata;
      return true;
    }
    return false;
  }

  public boolean hasMetadata() {
    return false; // FIX-ME should call type method
  }

  private Metadata metadata;
  private ATLASType type;
}