/*
 * ATLAS
 * Architecture and Tools for Linguistic Analysis Systems
 * Author: Chris Laprun, Sylvain Pajot
 *
 * This software was developed at the National Institute of Standards and Technology by
 * employees of the Federal Government in the course of their official duties.  Pursuant to
 * Title 17 Section 105 of the United States Code this software is not subject to copyright
 * protection within the United States and is in the public domain. jATLAS is
 * an experimental system.  NIST assumes no responsibility whatsoever for its use by any party.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS."  With regard to this software, NIST MAKES NO EXPRESS
 * OR IMPLIED WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING MERCHANTABILITY,
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 */

package gov.nist.atlas.impl;

import gov.nist.atlas.ATLASClass;
import gov.nist.atlas.ATLASElement;
import gov.nist.atlas.Corpus;
import gov.nist.atlas.MIMEClass;
import gov.nist.atlas.Unit;
import gov.nist.atlas.spi.TypeImplementationDelegate;
import gov.nist.atlas.type.ATLASType;
import gov.nist.atlas.type.AbstractATLASType;
import gov.nist.atlas.type.SignalType;
import gov.nist.maia.MAIAScheme;

/**
 * @author Christophe Laprun
 * @version $Revision: 1.2 $
 */
public class SignalTypeImpl extends AbstractATLASType implements SignalType {
  public SignalTypeImpl(ATLASType superType, String name, MAIAScheme scheme, TypeImplementationDelegate delegate) {
    super(superType, name, scheme, delegate);
  }

  public ATLASClass getATLASClass() {
    return ATLASClass.SIGNAL;
  }

  public boolean isParentValid(ATLASElement parent) {
    return parent instanceof Corpus;
  }

  public int getNumberOfDimensions() {
    return 0;
  }

  public String[] getDimensionNames() {
    return new String[0];
  }

  public Unit getUnitForDimension(String name) {
    return null;
  }

  public MIMEClass getMIMEClass() {
    return mimeClass;
  }

  public void setMimeClass(MIMEClass mimeClass) {
    this.mimeClass = mimeClass;
  }

  private MIMEClass mimeClass;
}



