/*
 * ATLAS
 * Architecture and Tools for Linguistic Analysis Systems
 * Author: Chris Laprun, Sylvain Pajot
 *
 * This software was developed at the National Institute of Standards and Technology by
 * employees of the Federal Government in the course of their official duties.  Pursuant to
 * Title 17 Section 105 of the United States Code this software is not subject to copyright
 * protection within the United States and is in the public domain. jATLAS is
 * an experimental system.  NIST assumes no responsibility whatsoever for its use by any party.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS."  With regard to this software, NIST MAKES NO EXPRESS
 * OR IMPLIED WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING MERCHANTABILITY,
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 */

package gov.nist.atlas.type;

import gov.nist.atlas.ATLASClass;


public class AnchorSpecificExtension extends ClassSpecificExtension {
  public AnchorSpecificExtension(ATLASType type) {
    super(type);
  }

  /**
   * @param
   * @return
   * @author Christophe Laprun
   * @version 1.0
   */
  public SignalType getSignalType() {
    return signalType;
  }

  public boolean setSignalType(SignalType signalType) {
    if (signalTypeAlreadySet)
      return false;
    this.signalType = signalType;
    signalTypeAlreadySet = true;
    return signalTypeAlreadySet;
  }

  protected void checkATLASType(ATLASType type) {
    if (type.getATLASClass() != ATLASClass.ANCHOR)
      throw new IllegalArgumentException("AnchorTypes must be of ATLASClass ANCHOR");
  }

  private SignalType signalType;
  private boolean signalTypeAlreadySet = false;
}



