/*
 * ATLAS
 * Architecture and Tools for Linguistic Analysis Systems
 * Author: Chris Laprun, Sylvain Pajot
 *
 * This software was developed at the National Institute of Standards and Technology by
 * employees of the Federal Government in the course of their official duties.  Pursuant to
 * Title 17 Section 105 of the United States Code this software is not subject to copyright
 * protection within the United States and is in the public domain. jATLAS is
 * an experimental system.  NIST assumes no responsibility whatsoever for its use by any party.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS."  With regard to this software, NIST MAKES NO EXPRESS
 * OR IMPLIED WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING MERCHANTABILITY,
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 */

package gov.nist.atlas.type;

import gov.nist.atlas.ref.AnchorRef;
import gov.nist.atlas.ref.AnnotationRef;
import gov.nist.atlas.ref.RegionRef;


public interface RegionType extends ATLASType {
  /**
   * Checks that the parameters that are needed to initialiaze Regions of this
   * RegionType are correct. More precisely, this method checks that: <ul>
   * <li>all the needed parameters are present</li>
   * <li>the present parameters have the right roles if appropriate</li>
   * <li>the present parameters are of the right type</li> </ul>
   * @exception IllegalArgumentException
   */
  void checkInitParameters(AnnotationRef[] annotations, RegionRef[] regions, AnchorRef[] anchors);
}



