/*
 * ATLAS
 * Architecture and Tools for Linguistic Analysis Systems
 * Author: Chris Laprun, Sylvain Pajot
 *
 * This software was developed at the National Institute of Standards and Technology by
 * employees of the Federal Government in the course of their official duties.  Pursuant to
 * Title 17 Section 105 of the United States Code this software is not subject to copyright
 * protection within the United States and is in the public domain. jATLAS is
 * an experimental system.  NIST assumes no responsibility whatsoever for its use by any party.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS."  With regard to this software, NIST MAKES NO EXPRESS
 * OR IMPLIED WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING MERCHANTABILITY,
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 */
package gov.nist.atlas.util;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 *
 */
public class ArrayIterator implements Iterator {
  public ArrayIterator(Object[] array) {
    this.array = array;
  }

  public boolean hasNext() {
    return (array != null) ? currentIndex < array.length : false;
  }

  public Object next() {
    if (!hasNext())
      throw new NoSuchElementException();
    return array[currentIndex++];
  }

  public void remove() {
    throw new UnsupportedOperationException("remove is not supported on this Iterator");
  }

  public static void main(String[] args) {
    String[] strings = new String[]{"this", "is", "a", "test"};
    Iterator i = new ArrayIterator(strings);
    while (i.hasNext())
      System.out.println(i.next());
  }

  private Object[] array;
  int currentIndex = 0;
}
