/*
 * ATLAS
 * Architecture and Tools for Linguistic Analysis Systems
 * Author: Chris Laprun, Sylvain Pajot
 *
 * This software was developed at the National Institute of Standards and Technology by
 * employees of the Federal Government in the course of their official duties.  Pursuant to
 * Title 17 Section 105 of the United States Code this software is not subject to copyright
 * protection within the United States and is in the public domain. jATLAS is
 * an experimental system.  NIST assumes no responsibility whatsoever for its use by any party.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS."  With regard to this software, NIST MAKES NO EXPRESS
 * OR IMPLIED WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING MERCHANTABILITY,
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 */

package gov.nist.atlas.util;

import gov.nist.atlas.ATLASClass;
import gov.nist.atlas.type.ATLASType;

import java.util.ArrayList;


/**
 * ArrayListATLASElementSet is an implementation of the
 * ListBasedATLASElementSet which uses an ArrayList.
 * Refer to {@link java.util.ArrayList} for the details about the advantages
 * using such a List.
 *
 * @version $Revision: 1.2 $
 * @author Christophe Laprun, Sylvain Pajot
 */
public class ArrayListATLASElementSet extends AbstractListBasedATLASElementSet implements FastAccessByIndex {

  public ArrayListATLASElementSet(ATLASType type, int size) {
    this(type, size, null);
  }

  public ArrayListATLASElementSet(ATLASClass clazz, int size) {
    this(clazz, size, null);
  }

  public ArrayListATLASElementSet(Object guard, int size, ATLASElementSetProperties properties) {
    super(guard, size, properties);
  }

  protected void initContainer(int size, ATLASElementSetProperties properties) {
    elements = new ArrayList(size);
  }
}

