/*
 * ATLAS
 * Architecture and Tools for Linguistic Analysis Systems
 * Author: Chris Laprun, Sylvain Pajot
 *
 * This software was developed at the National Institute of Standards and Technology by
 * employees of the Federal Government in the course of their official duties.  Pursuant to
 * Title 17 Section 105 of the United States Code this software is not subject to copyright
 * protection within the United States and is in the public domain. jATLAS is
 * an experimental system.  NIST assumes no responsibility whatsoever for its use by any party.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS."  With regard to this software, NIST MAKES NO EXPRESS
 * OR IMPLIED WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING MERCHANTABILITY,
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 */

package gov.nist.atlas.util;

import gov.nist.atlas.Parameter;


/**
 * A RoleIdentifiedParameter is a Parameter enhanced with a role.
 * <P>Such a Parameter only makes sense in the context of its containing
 * element (that is Content, Feature, Anchor).
 * <P>RoleWrapper is used to create a RoleIdentifiedParameter.
 *
 * @version $Revision: 1.2 $
 * @author Christophe Laprun, Sylvain Pajot
 * @see gov.nist.atlas.Parameter
 * @see gov.nist.atlas.util.RoleAddressable
 * @see gov.nist.atlas.util.RoleWrapper
 */
public interface RoleIdentifiedParameter extends RoleAddressable, Parameter {
}

